using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Globalization;
using System.IO;
using System.Text.RegularExpressions;
using System.Windows.Forms;
using System.Xml;

namespace Glow
{
	/// <summary>
	/// Zusammenfassung für Form1.
	/// </summary>
	public class MapForm : System.Windows.Forms.Form
	{
		private bool doWarning = true;
		private short[,] map = new short[1000, 1000];
		public static XmlDocument cfg = new XmlDocument();
		private EntityList entities = new EntityList();
		public static NumberFormatInfo provider = new NumberFormatInfo();
		private Random rand = new Random();
		/// <summary>
		/// Erforderliche Designervariable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.NumericUpDown numericUpDownHill;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Panel panelToolbar;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.NumericUpDown numericUpDownWidth;
		private System.Windows.Forms.NumericUpDown numericUpDownHeight;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.NumericUpDown numericUpDownZoom;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.NumericUpDown numericUpDownWall;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.NumericUpDown numericUpDownThickness;
		private System.Windows.Forms.NumericUpDown numericUpDownBackUp;
		private System.Windows.Forms.NumericUpDown numericUpDownBackDown;
		private System.Windows.Forms.CheckBox checkBoxClose;
		private System.Windows.Forms.Button buttonFill;
		private System.Windows.Forms.Button buttonClear;
		private System.Windows.Forms.Button buttonSave;
		private System.Windows.Forms.Button buttonAddLineInv;
		private System.Windows.Forms.Button buttonAddRoom;
		private System.Windows.Forms.Button buttonAddLine;
		private System.Windows.Forms.SaveFileDialog saveFileDialog1;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.NumericUpDown numericUpDownBack;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.Label label11;
		private System.Windows.Forms.Label label12;
		private System.Windows.Forms.Label label13;
		private System.Windows.Forms.NumericUpDown numericUpDownRWT;
		private System.Windows.Forms.NumericUpDown numericUpDownRHT;
		private System.Windows.Forms.NumericUpDown numericUpDownRWF;
		private System.Windows.Forms.NumericUpDown numericUpDownRHF;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.Button buttonRandom;
		private System.Windows.Forms.Label label14;
		private System.Windows.Forms.Label label15;
		private System.Windows.Forms.GroupBox groupBox4;
		private System.Windows.Forms.NumericUpDown numericUpDownRndFloors;
		private System.Windows.Forms.NumericUpDown numericUpDownRndRooms;
		private System.Windows.Forms.CheckBox checkBoxInv;
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		private System.Windows.Forms.NumericUpDown numericUpDownRetries;
		private System.Windows.Forms.Label label16;
		private System.Windows.Forms.Label label17;
		private System.Windows.Forms.Label label18;
		private System.Windows.Forms.Button buttonFillBG;
		private System.Windows.Forms.Button buttonOpen;
		private System.Windows.Forms.ComboBox comboBoxSetBG;
		private System.Windows.Forms.ComboBox comboBoxSet;
		private System.Windows.Forms.Button buttonOptimize;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.Button buttonFractal;
		private System.Windows.Forms.CheckBox checkBoxSymmetry;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.GroupBox groupBox5;
		private System.Windows.Forms.Label label19;
		private System.Windows.Forms.ComboBox comboBoxScheme;

		private int width
		{
			get { return (int)numericUpDownWidth.Value; }
			set { numericUpDownWidth.Value = value; }
		}
		private int height
		{
			get { return (int)numericUpDownHeight.Value; }
			set { numericUpDownHeight.Value = value; }
		}
		private int zoom
		{
			get { return (int)(numericUpDownZoom.Value / 100); }
			set { numericUpDownZoom.Value = value * 100; }
		}

		public MapForm()
		{
			//
			// Erforderlich für die Windows Form-Designerunterstützung
			//
			InitializeComponent();
			SetStyle(ControlStyles.UserPaint |
				ControlStyles.AllPaintingInWmPaint |
				ControlStyles.DoubleBuffer, true);
			provider.NumberDecimalSeparator = ".";
			doFill(-1);
			comboBoxSet.SelectedIndex = 0;
			comboBoxSetBG.SelectedIndex = 4;
			loadConfig();
		}

		private bool loadConfig()
		{
			string filename = Application.StartupPath + Path.DirectorySeparatorChar + "Map-Tool.xml";
			if (! File.Exists(filename))
			{
				MessageBox.Show(this, filename + "\r\nnicht gefunden!", "Fehler");
				return false;
			}
			cfg.Load(filename);
			int index = comboBoxScheme.SelectedIndex;

			comboBoxScheme.SelectedIndexChanged -= new System.EventHandler(comboBoxScheme_SelectedIndexChanged);

			comboBoxScheme.Items.Clear();
			foreach (XmlNode node in cfg.SelectNodes("*/Colorscheme/@name"))
			{
				comboBoxScheme.Items.Add(node.Value);
			}
			if (index < comboBoxScheme.Items.Count)
				comboBoxScheme.SelectedIndex = index;
			if (comboBoxScheme.SelectedIndex < 0 && comboBoxScheme.Items.Count > 0)
				comboBoxScheme.SelectedIndex = 0;

			comboBoxScheme.SelectedIndexChanged += new System.EventHandler(comboBoxScheme_SelectedIndexChanged);

			return true;
		}

		/// <summary>
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Windows Form-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode für die Designerunterstützung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor geändert werden.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MapForm));
			this.panelToolbar = new System.Windows.Forms.Panel();
			this.buttonFillBG = new System.Windows.Forms.Button();
			this.buttonFill = new System.Windows.Forms.Button();
			this.numericUpDownBack = new System.Windows.Forms.NumericUpDown();
			this.buttonClear = new System.Windows.Forms.Button();
			this.numericUpDownHeight = new System.Windows.Forms.NumericUpDown();
			this.numericUpDownWidth = new System.Windows.Forms.NumericUpDown();
			this.groupBox4 = new System.Windows.Forms.GroupBox();
			this.buttonOpen = new System.Windows.Forms.Button();
			this.buttonSave = new System.Windows.Forms.Button();
			this.comboBoxSetBG = new System.Windows.Forms.ComboBox();
			this.comboBoxSet = new System.Windows.Forms.ComboBox();
			this.label18 = new System.Windows.Forms.Label();
			this.label17 = new System.Windows.Forms.Label();
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.buttonRandom = new System.Windows.Forms.Button();
			this.numericUpDownRetries = new System.Windows.Forms.NumericUpDown();
			this.numericUpDownRndFloors = new System.Windows.Forms.NumericUpDown();
			this.numericUpDownRndRooms = new System.Windows.Forms.NumericUpDown();
			this.label16 = new System.Windows.Forms.Label();
			this.label15 = new System.Windows.Forms.Label();
			this.label14 = new System.Windows.Forms.Label();
			this.checkBoxInv = new System.Windows.Forms.CheckBox();
			this.buttonOptimize = new System.Windows.Forms.Button();
			this.buttonFractal = new System.Windows.Forms.Button();
			this.label9 = new System.Windows.Forms.Label();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.buttonAddRoom = new System.Windows.Forms.Button();
			this.numericUpDownRHF = new System.Windows.Forms.NumericUpDown();
			this.numericUpDownRWF = new System.Windows.Forms.NumericUpDown();
			this.numericUpDownRHT = new System.Windows.Forms.NumericUpDown();
			this.numericUpDownRWT = new System.Windows.Forms.NumericUpDown();
			this.numericUpDownWall = new System.Windows.Forms.NumericUpDown();
			this.label12 = new System.Windows.Forms.Label();
			this.label13 = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.checkBoxClose = new System.Windows.Forms.CheckBox();
			this.label10 = new System.Windows.Forms.Label();
			this.label11 = new System.Windows.Forms.Label();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.buttonAddLine = new System.Windows.Forms.Button();
			this.buttonAddLineInv = new System.Windows.Forms.Button();
			this.numericUpDownHill = new System.Windows.Forms.NumericUpDown();
			this.numericUpDownThickness = new System.Windows.Forms.NumericUpDown();
			this.numericUpDownBackUp = new System.Windows.Forms.NumericUpDown();
			this.numericUpDownBackDown = new System.Windows.Forms.NumericUpDown();
			this.label6 = new System.Windows.Forms.Label();
			this.label7 = new System.Windows.Forms.Label();
			this.label8 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.checkBoxSymmetry = new System.Windows.Forms.CheckBox();
			this.label3 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.groupBox5 = new System.Windows.Forms.GroupBox();
			this.label19 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.numericUpDownZoom = new System.Windows.Forms.NumericUpDown();
			this.comboBoxScheme = new System.Windows.Forms.ComboBox();
			this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.panel1 = new System.Windows.Forms.Panel();
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.panelToolbar.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownBack)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownHeight)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownWidth)).BeginInit();
			this.groupBox4.SuspendLayout();
			this.groupBox3.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownRetries)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownRndFloors)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownRndRooms)).BeginInit();
			this.groupBox2.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownRHF)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownRWF)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownRHT)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownRWT)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownWall)).BeginInit();
			this.groupBox1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownHill)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownThickness)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownBackUp)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownBackDown)).BeginInit();
			this.groupBox5.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownZoom)).BeginInit();
			this.panel1.SuspendLayout();
			this.SuspendLayout();
			// 
			// panelToolbar
			// 
			this.panelToolbar.Controls.Add(this.buttonFillBG);
			this.panelToolbar.Controls.Add(this.buttonFill);
			this.panelToolbar.Controls.Add(this.numericUpDownBack);
			this.panelToolbar.Controls.Add(this.buttonClear);
			this.panelToolbar.Controls.Add(this.numericUpDownHeight);
			this.panelToolbar.Controls.Add(this.numericUpDownWidth);
			this.panelToolbar.Controls.Add(this.groupBox4);
			this.panelToolbar.Controls.Add(this.groupBox3);
			this.panelToolbar.Controls.Add(this.label9);
			this.panelToolbar.Controls.Add(this.groupBox2);
			this.panelToolbar.Controls.Add(this.groupBox1);
			this.panelToolbar.Controls.Add(this.label3);
			this.panelToolbar.Controls.Add(this.label2);
			this.panelToolbar.Controls.Add(this.groupBox5);
			this.panelToolbar.Dock = System.Windows.Forms.DockStyle.Right;
			this.panelToolbar.Location = new System.Drawing.Point(448, 0);
			this.panelToolbar.Name = "panelToolbar";
			this.panelToolbar.Size = new System.Drawing.Size(344, 574);
			this.panelToolbar.TabIndex = 0;
			// 
			// buttonFillBG
			// 
			this.buttonFillBG.Location = new System.Drawing.Point(16, 216);
			this.buttonFillBG.Name = "buttonFillBG";
			this.buttonFillBG.Size = new System.Drawing.Size(144, 23);
			this.buttonFillBG.TabIndex = 10;
			this.buttonFillBG.Text = "Hintergrundebene füllen";
			this.buttonFillBG.Click += new System.EventHandler(this.buttonFillBG_Click);
			// 
			// buttonFill
			// 
			this.buttonFill.Location = new System.Drawing.Point(16, 192);
			this.buttonFill.Name = "buttonFill";
			this.buttonFill.Size = new System.Drawing.Size(144, 23);
			this.buttonFill.TabIndex = 9;
			this.buttonFill.Text = "Normale Ebene &füllen";
			this.buttonFill.Click += new System.EventHandler(this.buttonFill_Click);
			// 
			// numericUpDownBack
			// 
			this.numericUpDownBack.Increment = new System.Decimal(new int[] {
																				2,
																				0,
																				0,
																				0});
			this.numericUpDownBack.Location = new System.Drawing.Point(112, 168);
			this.numericUpDownBack.Name = "numericUpDownBack";
			this.numericUpDownBack.Size = new System.Drawing.Size(48, 20);
			this.numericUpDownBack.TabIndex = 8;
			this.numericUpDownBack.Value = new System.Decimal(new int[] {
																			100,
																			0,
																			0,
																			0});
			// 
			// buttonClear
			// 
			this.buttonClear.Location = new System.Drawing.Point(16, 136);
			this.buttonClear.Name = "buttonClear";
			this.buttonClear.Size = new System.Drawing.Size(144, 23);
			this.buttonClear.TabIndex = 6;
			this.buttonClear.Text = "Alles &löschen";
			this.buttonClear.Click += new System.EventHandler(this.buttonClear_Click);
			// 
			// numericUpDownHeight
			// 
			this.numericUpDownHeight.Increment = new System.Decimal(new int[] {
																				  10,
																				  0,
																				  0,
																				  0});
			this.numericUpDownHeight.Location = new System.Drawing.Point(112, 112);
			this.numericUpDownHeight.Maximum = new System.Decimal(new int[] {
																				1000,
																				0,
																				0,
																				0});
			this.numericUpDownHeight.Minimum = new System.Decimal(new int[] {
																				22,
																				0,
																				0,
																				0});
			this.numericUpDownHeight.Name = "numericUpDownHeight";
			this.numericUpDownHeight.Size = new System.Drawing.Size(48, 20);
			this.numericUpDownHeight.TabIndex = 5;
			this.numericUpDownHeight.Value = new System.Decimal(new int[] {
																			  50,
																			  0,
																			  0,
																			  0});
			this.numericUpDownHeight.ValueChanged += new System.EventHandler(this.doRefresh);
			// 
			// numericUpDownWidth
			// 
			this.numericUpDownWidth.Increment = new System.Decimal(new int[] {
																				 10,
																				 0,
																				 0,
																				 0});
			this.numericUpDownWidth.Location = new System.Drawing.Point(112, 88);
			this.numericUpDownWidth.Maximum = new System.Decimal(new int[] {
																			   1000,
																			   0,
																			   0,
																			   0});
			this.numericUpDownWidth.Minimum = new System.Decimal(new int[] {
																			   32,
																			   0,
																			   0,
																			   0});
			this.numericUpDownWidth.Name = "numericUpDownWidth";
			this.numericUpDownWidth.Size = new System.Drawing.Size(48, 20);
			this.numericUpDownWidth.TabIndex = 3;
			this.numericUpDownWidth.Value = new System.Decimal(new int[] {
																			 100,
																			 0,
																			 0,
																			 0});
			this.numericUpDownWidth.ValueChanged += new System.EventHandler(this.doRefresh);
			// 
			// groupBox4
			// 
			this.groupBox4.Controls.Add(this.buttonOpen);
			this.groupBox4.Controls.Add(this.buttonSave);
			this.groupBox4.Controls.Add(this.comboBoxSetBG);
			this.groupBox4.Controls.Add(this.comboBoxSet);
			this.groupBox4.Controls.Add(this.label18);
			this.groupBox4.Controls.Add(this.label17);
			this.groupBox4.Location = new System.Drawing.Point(8, 464);
			this.groupBox4.Name = "groupBox4";
			this.groupBox4.Size = new System.Drawing.Size(328, 96);
			this.groupBox4.TabIndex = 14;
			this.groupBox4.TabStop = false;
			this.groupBox4.Text = "Speichern";
			// 
			// buttonOpen
			// 
			this.buttonOpen.Location = new System.Drawing.Point(8, 64);
			this.buttonOpen.Name = "buttonOpen";
			this.buttonOpen.Size = new System.Drawing.Size(64, 23);
			this.buttonOpen.TabIndex = 0;
			this.buttonOpen.Text = "Ö&ffnen...";
			this.buttonOpen.Click += new System.EventHandler(this.buttonOpen_Click);
			// 
			// buttonSave
			// 
			this.buttonSave.Location = new System.Drawing.Point(80, 64);
			this.buttonSave.Name = "buttonSave";
			this.buttonSave.Size = new System.Drawing.Size(240, 23);
			this.buttonSave.TabIndex = 5;
			this.buttonSave.Text = "&Speichern unter...";
			this.buttonSave.Click += new System.EventHandler(this.buttonSave_Click);
			// 
			// comboBoxSetBG
			// 
			this.comboBoxSetBG.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboBoxSetBG.Items.AddRange(new object[] {
															   "Platte Set 1",
															   "Platte Set 2",
															   "Platte Set 3",
															   "Platte Set 4",
															   "Platte BG Set 1",
															   "Platte BG Set 2",
															   "Platte BG Set 3",
															   "Platte BG Set 4",
															   "BlutPlatte Set 1",
															   "BlutPlatte Set 2",
															   "BlutPlatte Set 3",
															   "BlutPlatte Set 4"});
			this.comboBoxSetBG.Location = new System.Drawing.Point(176, 40);
			this.comboBoxSetBG.MaxDropDownItems = 12;
			this.comboBoxSetBG.Name = "comboBoxSetBG";
			this.comboBoxSetBG.Size = new System.Drawing.Size(144, 21);
			this.comboBoxSetBG.TabIndex = 4;
			// 
			// comboBoxSet
			// 
			this.comboBoxSet.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboBoxSet.Items.AddRange(new object[] {
															 "Platte Set 1",
															 "Platte Set 2",
															 "Platte Set 3",
															 "Platte Set 4",
															 "Platte BG Set 1",
															 "Platte BG Set 2",
															 "Platte BG Set 3",
															 "Platte BG Set 4",
															 "BlutPlatte Set 1",
															 "BlutPlatte Set 2",
															 "BlutPlatte Set 3",
															 "BlutPlatte Set 4"});
			this.comboBoxSet.Location = new System.Drawing.Point(176, 16);
			this.comboBoxSet.MaxDropDownItems = 12;
			this.comboBoxSet.Name = "comboBoxSet";
			this.comboBoxSet.Size = new System.Drawing.Size(144, 21);
			this.comboBoxSet.TabIndex = 2;
			// 
			// label18
			// 
			this.label18.AutoSize = true;
			this.label18.Location = new System.Drawing.Point(80, 44);
			this.label18.Name = "label18";
			this.label18.Size = new System.Drawing.Size(98, 16);
			this.label18.TabIndex = 3;
			this.label18.Text = "Hintergrundebene:";
			// 
			// label17
			// 
			this.label17.AutoSize = true;
			this.label17.Location = new System.Drawing.Point(80, 20);
			this.label17.Name = "label17";
			this.label17.Size = new System.Drawing.Size(86, 16);
			this.label17.TabIndex = 1;
			this.label17.Text = "Normale Ebene:";
			// 
			// groupBox3
			// 
			this.groupBox3.Controls.Add(this.buttonRandom);
			this.groupBox3.Controls.Add(this.numericUpDownRetries);
			this.groupBox3.Controls.Add(this.numericUpDownRndFloors);
			this.groupBox3.Controls.Add(this.numericUpDownRndRooms);
			this.groupBox3.Controls.Add(this.label16);
			this.groupBox3.Controls.Add(this.label15);
			this.groupBox3.Controls.Add(this.label14);
			this.groupBox3.Controls.Add(this.checkBoxInv);
			this.groupBox3.Controls.Add(this.buttonOptimize);
			this.groupBox3.Controls.Add(this.buttonFractal);
			this.groupBox3.Location = new System.Drawing.Point(8, 248);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(160, 208);
			this.groupBox3.TabIndex = 11;
			this.groupBox3.TabStop = false;
			this.groupBox3.Text = "Zufall";
			// 
			// buttonRandom
			// 
			this.buttonRandom.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.buttonRandom.Location = new System.Drawing.Point(8, 120);
			this.buttonRandom.Name = "buttonRandom";
			this.buttonRandom.Size = new System.Drawing.Size(144, 23);
			this.buttonRandom.TabIndex = 7;
			this.buttonRandom.Text = "&Zufallslevel";
			this.buttonRandom.Click += new System.EventHandler(this.buttonRandom_Click);
			// 
			// numericUpDownRetries
			// 
			this.numericUpDownRetries.Increment = new System.Decimal(new int[] {
																				   10,
																				   0,
																				   0,
																				   0});
			this.numericUpDownRetries.Location = new System.Drawing.Point(104, 24);
			this.numericUpDownRetries.Maximum = new System.Decimal(new int[] {
																				 10000,
																				 0,
																				 0,
																				 0});
			this.numericUpDownRetries.Minimum = new System.Decimal(new int[] {
																				 1,
																				 0,
																				 0,
																				 0});
			this.numericUpDownRetries.Name = "numericUpDownRetries";
			this.numericUpDownRetries.Size = new System.Drawing.Size(48, 20);
			this.numericUpDownRetries.TabIndex = 1;
			this.numericUpDownRetries.Value = new System.Decimal(new int[] {
																			   100,
																			   0,
																			   0,
																			   0});
			// 
			// numericUpDownRndFloors
			// 
			this.numericUpDownRndFloors.Location = new System.Drawing.Point(104, 48);
			this.numericUpDownRndFloors.Maximum = new System.Decimal(new int[] {
																				   10000,
																				   0,
																				   0,
																				   0});
			this.numericUpDownRndFloors.Name = "numericUpDownRndFloors";
			this.numericUpDownRndFloors.Size = new System.Drawing.Size(48, 20);
			this.numericUpDownRndFloors.TabIndex = 3;
			this.numericUpDownRndFloors.Value = new System.Decimal(new int[] {
																				 5,
																				 0,
																				 0,
																				 0});
			// 
			// numericUpDownRndRooms
			// 
			this.numericUpDownRndRooms.Location = new System.Drawing.Point(104, 72);
			this.numericUpDownRndRooms.Maximum = new System.Decimal(new int[] {
																				  10000,
																				  0,
																				  0,
																				  0});
			this.numericUpDownRndRooms.Name = "numericUpDownRndRooms";
			this.numericUpDownRndRooms.Size = new System.Drawing.Size(48, 20);
			this.numericUpDownRndRooms.TabIndex = 5;
			this.numericUpDownRndRooms.Value = new System.Decimal(new int[] {
																				3,
																				0,
																				0,
																				0});
			// 
			// label16
			// 
			this.label16.AutoSize = true;
			this.label16.Location = new System.Drawing.Point(8, 26);
			this.label16.Name = "label16";
			this.label16.Size = new System.Drawing.Size(86, 16);
			this.label16.TabIndex = 0;
			this.label16.Text = "Regelmäßigkeit:";
			// 
			// label15
			// 
			this.label15.AutoSize = true;
			this.label15.Location = new System.Drawing.Point(8, 74);
			this.label15.Name = "label15";
			this.label15.Size = new System.Drawing.Size(82, 16);
			this.label15.TabIndex = 4;
			this.label15.Text = "Anzahl Räume:";
			// 
			// label14
			// 
			this.label14.AutoSize = true;
			this.label14.Location = new System.Drawing.Point(8, 50);
			this.label14.Name = "label14";
			this.label14.Size = new System.Drawing.Size(78, 16);
			this.label14.TabIndex = 2;
			this.label14.Text = "Anzahl Böden:";
			// 
			// checkBoxInv
			// 
			this.checkBoxInv.Location = new System.Drawing.Point(8, 96);
			this.checkBoxInv.Name = "checkBoxInv";
			this.checkBoxInv.Size = new System.Drawing.Size(144, 16);
			this.checkBoxInv.TabIndex = 6;
			this.checkBoxInv.Text = "Unterirdisch";
			// 
			// buttonOptimize
			// 
			this.buttonOptimize.Location = new System.Drawing.Point(8, 176);
			this.buttonOptimize.Name = "buttonOptimize";
			this.buttonOptimize.Size = new System.Drawing.Size(144, 23);
			this.buttonOptimize.TabIndex = 8;
			this.buttonOptimize.Text = "Weniger kleine Steine";
			this.buttonOptimize.Click += new System.EventHandler(this.buttonOptimize_Click);
			// 
			// buttonFractal
			// 
			this.buttonFractal.Location = new System.Drawing.Point(8, 152);
			this.buttonFractal.Name = "buttonFractal";
			this.buttonFractal.Size = new System.Drawing.Size(144, 23);
			this.buttonFractal.TabIndex = 15;
			this.buttonFractal.Text = "Hintergrund verrauschen";
			this.buttonFractal.Click += new System.EventHandler(this.buttonFractal_Click);
			// 
			// label9
			// 
			this.label9.AutoSize = true;
			this.label9.Location = new System.Drawing.Point(16, 170);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(72, 16);
			this.label9.TabIndex = 7;
			this.label9.Text = "Füllhöhe (%):";
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.buttonAddRoom);
			this.groupBox2.Controls.Add(this.numericUpDownRHF);
			this.groupBox2.Controls.Add(this.numericUpDownRWF);
			this.groupBox2.Controls.Add(this.numericUpDownRHT);
			this.groupBox2.Controls.Add(this.numericUpDownRWT);
			this.groupBox2.Controls.Add(this.numericUpDownWall);
			this.groupBox2.Controls.Add(this.label12);
			this.groupBox2.Controls.Add(this.label13);
			this.groupBox2.Controls.Add(this.label5);
			this.groupBox2.Controls.Add(this.checkBoxClose);
			this.groupBox2.Controls.Add(this.label10);
			this.groupBox2.Controls.Add(this.label11);
			this.groupBox2.Location = new System.Drawing.Point(176, 304);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(160, 152);
			this.groupBox2.TabIndex = 13;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Räume";
			// 
			// buttonAddRoom
			// 
			this.buttonAddRoom.Location = new System.Drawing.Point(8, 120);
			this.buttonAddRoom.Name = "buttonAddRoom";
			this.buttonAddRoom.Size = new System.Drawing.Size(144, 23);
			this.buttonAddRoom.TabIndex = 11;
			this.buttonAddRoom.Text = "&Raum hinzufügen";
			this.buttonAddRoom.Click += new System.EventHandler(this.buttonRoom_Click);
			// 
			// numericUpDownRHF
			// 
			this.numericUpDownRHF.Increment = new System.Decimal(new int[] {
																			   2,
																			   0,
																			   0,
																			   0});
			this.numericUpDownRHF.Location = new System.Drawing.Point(48, 72);
			this.numericUpDownRHF.Maximum = new System.Decimal(new int[] {
																			 1000,
																			 0,
																			 0,
																			 0});
			this.numericUpDownRHF.Minimum = new System.Decimal(new int[] {
																			 4,
																			 0,
																			 0,
																			 0});
			this.numericUpDownRHF.Name = "numericUpDownRHF";
			this.numericUpDownRHF.Size = new System.Drawing.Size(40, 20);
			this.numericUpDownRHF.TabIndex = 7;
			this.numericUpDownRHF.Value = new System.Decimal(new int[] {
																		   6,
																		   0,
																		   0,
																		   0});
			this.numericUpDownRHF.ValueChanged += new System.EventHandler(this.numericUpDownRHF_ValueChanged);
			// 
			// numericUpDownRWF
			// 
			this.numericUpDownRWF.Increment = new System.Decimal(new int[] {
																			   2,
																			   0,
																			   0,
																			   0});
			this.numericUpDownRWF.Location = new System.Drawing.Point(48, 48);
			this.numericUpDownRWF.Maximum = new System.Decimal(new int[] {
																			 1000,
																			 0,
																			 0,
																			 0});
			this.numericUpDownRWF.Minimum = new System.Decimal(new int[] {
																			 4,
																			 0,
																			 0,
																			 0});
			this.numericUpDownRWF.Name = "numericUpDownRWF";
			this.numericUpDownRWF.Size = new System.Drawing.Size(40, 20);
			this.numericUpDownRWF.TabIndex = 3;
			this.numericUpDownRWF.Value = new System.Decimal(new int[] {
																		   8,
																		   0,
																		   0,
																		   0});
			this.numericUpDownRWF.ValueChanged += new System.EventHandler(this.numericUpDownRWF_ValueChanged);
			// 
			// numericUpDownRHT
			// 
			this.numericUpDownRHT.Increment = new System.Decimal(new int[] {
																			   2,
																			   0,
																			   0,
																			   0});
			this.numericUpDownRHT.Location = new System.Drawing.Point(112, 72);
			this.numericUpDownRHT.Maximum = new System.Decimal(new int[] {
																			 1000,
																			 0,
																			 0,
																			 0});
			this.numericUpDownRHT.Minimum = new System.Decimal(new int[] {
																			 4,
																			 0,
																			 0,
																			 0});
			this.numericUpDownRHT.Name = "numericUpDownRHT";
			this.numericUpDownRHT.Size = new System.Drawing.Size(40, 20);
			this.numericUpDownRHT.TabIndex = 9;
			this.numericUpDownRHT.Value = new System.Decimal(new int[] {
																		   16,
																		   0,
																		   0,
																		   0});
			this.numericUpDownRHT.ValueChanged += new System.EventHandler(this.numericUpDownRHT_ValueChanged);
			// 
			// numericUpDownRWT
			// 
			this.numericUpDownRWT.Increment = new System.Decimal(new int[] {
																			   2,
																			   0,
																			   0,
																			   0});
			this.numericUpDownRWT.Location = new System.Drawing.Point(112, 48);
			this.numericUpDownRWT.Maximum = new System.Decimal(new int[] {
																			 1000,
																			 0,
																			 0,
																			 0});
			this.numericUpDownRWT.Minimum = new System.Decimal(new int[] {
																			 4,
																			 0,
																			 0,
																			 0});
			this.numericUpDownRWT.Name = "numericUpDownRWT";
			this.numericUpDownRWT.Size = new System.Drawing.Size(40, 20);
			this.numericUpDownRWT.TabIndex = 5;
			this.numericUpDownRWT.Value = new System.Decimal(new int[] {
																		   64,
																		   0,
																		   0,
																		   0});
			this.numericUpDownRWT.ValueChanged += new System.EventHandler(this.numericUpDownRWT_ValueChanged);
			// 
			// numericUpDownWall
			// 
			this.numericUpDownWall.Increment = new System.Decimal(new int[] {
																				2,
																				0,
																				0,
																				0});
			this.numericUpDownWall.Location = new System.Drawing.Point(104, 24);
			this.numericUpDownWall.Maximum = new System.Decimal(new int[] {
																			  1000,
																			  0,
																			  0,
																			  0});
			this.numericUpDownWall.Name = "numericUpDownWall";
			this.numericUpDownWall.Size = new System.Drawing.Size(48, 20);
			this.numericUpDownWall.TabIndex = 1;
			this.numericUpDownWall.Value = new System.Decimal(new int[] {
																			4,
																			0,
																			0,
																			0});
			// 
			// label12
			// 
			this.label12.AutoSize = true;
			this.label12.Location = new System.Drawing.Point(8, 74);
			this.label12.Name = "label12";
			this.label12.Size = new System.Drawing.Size(34, 16);
			this.label12.TabIndex = 6;
			this.label12.Text = "Höhe:";
			// 
			// label13
			// 
			this.label13.AutoSize = true;
			this.label13.Location = new System.Drawing.Point(8, 50);
			this.label13.Name = "label13";
			this.label13.Size = new System.Drawing.Size(37, 16);
			this.label13.TabIndex = 2;
			this.label13.Text = "Breite:";
			// 
			// label5
			// 
			this.label5.AutoSize = true;
			this.label5.Location = new System.Drawing.Point(8, 26);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(68, 16);
			this.label5.TabIndex = 0;
			this.label5.Text = "Wandstärke:";
			// 
			// checkBoxClose
			// 
			this.checkBoxClose.Location = new System.Drawing.Point(8, 96);
			this.checkBoxClose.Name = "checkBoxClose";
			this.checkBoxClose.Size = new System.Drawing.Size(144, 16);
			this.checkBoxClose.TabIndex = 10;
			this.checkBoxClose.Text = "Rückwand";
			// 
			// label10
			// 
			this.label10.AutoSize = true;
			this.label10.Location = new System.Drawing.Point(90, 50);
			this.label10.Name = "label10";
			this.label10.Size = new System.Drawing.Size(19, 16);
			this.label10.TabIndex = 4;
			this.label10.Text = "bis";
			// 
			// label11
			// 
			this.label11.AutoSize = true;
			this.label11.Location = new System.Drawing.Point(90, 74);
			this.label11.Name = "label11";
			this.label11.Size = new System.Drawing.Size(19, 16);
			this.label11.TabIndex = 8;
			this.label11.Text = "bis";
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.buttonAddLine);
			this.groupBox1.Controls.Add(this.buttonAddLineInv);
			this.groupBox1.Controls.Add(this.numericUpDownHill);
			this.groupBox1.Controls.Add(this.numericUpDownThickness);
			this.groupBox1.Controls.Add(this.numericUpDownBackUp);
			this.groupBox1.Controls.Add(this.numericUpDownBackDown);
			this.groupBox1.Controls.Add(this.label6);
			this.groupBox1.Controls.Add(this.label7);
			this.groupBox1.Controls.Add(this.label8);
			this.groupBox1.Controls.Add(this.label4);
			this.groupBox1.Controls.Add(this.checkBoxSymmetry);
			this.groupBox1.Location = new System.Drawing.Point(176, 96);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(160, 200);
			this.groupBox1.TabIndex = 12;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Böden";
			// 
			// buttonAddLine
			// 
			this.buttonAddLine.Location = new System.Drawing.Point(8, 144);
			this.buttonAddLine.Name = "buttonAddLine";
			this.buttonAddLine.Size = new System.Drawing.Size(144, 23);
			this.buttonAddLine.TabIndex = 8;
			this.buttonAddLine.Text = "&Boden hinzufügen";
			this.buttonAddLine.Click += new System.EventHandler(this.buttonLine_Click);
			// 
			// buttonAddLineInv
			// 
			this.buttonAddLineInv.Location = new System.Drawing.Point(8, 168);
			this.buttonAddLineInv.Name = "buttonAddLineInv";
			this.buttonAddLineInv.Size = new System.Drawing.Size(144, 23);
			this.buttonAddLineInv.TabIndex = 9;
			this.buttonAddLineInv.Text = "&Tunnel hinzufügen";
			this.buttonAddLineInv.Click += new System.EventHandler(this.buttonLineInv_Click);
			// 
			// numericUpDownHill
			// 
			this.numericUpDownHill.DecimalPlaces = 1;
			this.numericUpDownHill.Increment = new System.Decimal(new int[] {
																				1,
																				0,
																				0,
																				65536});
			this.numericUpDownHill.Location = new System.Drawing.Point(104, 24);
			this.numericUpDownHill.Minimum = new System.Decimal(new int[] {
																			  1,
																			  0,
																			  0,
																			  65536});
			this.numericUpDownHill.Name = "numericUpDownHill";
			this.numericUpDownHill.Size = new System.Drawing.Size(48, 20);
			this.numericUpDownHill.TabIndex = 1;
			this.numericUpDownHill.Value = new System.Decimal(new int[] {
																			2,
																			0,
																			0,
																			0});
			// 
			// numericUpDownThickness
			// 
			this.numericUpDownThickness.Location = new System.Drawing.Point(104, 48);
			this.numericUpDownThickness.Maximum = new System.Decimal(new int[] {
																				   1000,
																				   0,
																				   0,
																				   0});
			this.numericUpDownThickness.Name = "numericUpDownThickness";
			this.numericUpDownThickness.Size = new System.Drawing.Size(48, 20);
			this.numericUpDownThickness.TabIndex = 3;
			this.numericUpDownThickness.Value = new System.Decimal(new int[] {
																				 4,
																				 0,
																				 0,
																				 0});
			// 
			// numericUpDownBackUp
			// 
			this.numericUpDownBackUp.Location = new System.Drawing.Point(104, 72);
			this.numericUpDownBackUp.Maximum = new System.Decimal(new int[] {
																				1000,
																				0,
																				0,
																				0});
			this.numericUpDownBackUp.Name = "numericUpDownBackUp";
			this.numericUpDownBackUp.Size = new System.Drawing.Size(48, 20);
			this.numericUpDownBackUp.TabIndex = 5;
			this.numericUpDownBackUp.Value = new System.Decimal(new int[] {
																			  6,
																			  0,
																			  0,
																			  0});
			// 
			// numericUpDownBackDown
			// 
			this.numericUpDownBackDown.Location = new System.Drawing.Point(104, 96);
			this.numericUpDownBackDown.Maximum = new System.Decimal(new int[] {
																				  1000,
																				  0,
																				  0,
																				  0});
			this.numericUpDownBackDown.Name = "numericUpDownBackDown";
			this.numericUpDownBackDown.Size = new System.Drawing.Size(48, 20);
			this.numericUpDownBackDown.TabIndex = 7;
			// 
			// label6
			// 
			this.label6.AutoSize = true;
			this.label6.Location = new System.Drawing.Point(8, 50);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(36, 16);
			this.label6.TabIndex = 2;
			this.label6.Text = "Dicke:";
			// 
			// label7
			// 
			this.label7.AutoSize = true;
			this.label7.Location = new System.Drawing.Point(8, 74);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(88, 16);
			this.label7.TabIndex = 4;
			this.label7.Text = "Rückwand hoch:";
			// 
			// label8
			// 
			this.label8.AutoSize = true;
			this.label8.Location = new System.Drawing.Point(8, 98);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(93, 16);
			this.label8.TabIndex = 6;
			this.label8.Text = "Rückwand runter:";
			// 
			// label4
			// 
			this.label4.AutoSize = true;
			this.label4.Location = new System.Drawing.Point(8, 26);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(50, 16);
			this.label4.TabIndex = 0;
			this.label4.Text = "Glättung:";
			// 
			// checkBoxSymmetry
			// 
			this.checkBoxSymmetry.Location = new System.Drawing.Point(8, 120);
			this.checkBoxSymmetry.Name = "checkBoxSymmetry";
			this.checkBoxSymmetry.Size = new System.Drawing.Size(144, 16);
			this.checkBoxSymmetry.TabIndex = 10;
			this.checkBoxSymmetry.Text = "Symmetrisch";
			// 
			// label3
			// 
			this.label3.AutoSize = true;
			this.label3.Location = new System.Drawing.Point(16, 114);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(69, 16);
			this.label3.TabIndex = 4;
			this.label3.Text = "Höhe (Tiles):";
			// 
			// label2
			// 
			this.label2.AutoSize = true;
			this.label2.Location = new System.Drawing.Point(16, 90);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(72, 16);
			this.label2.TabIndex = 2;
			this.label2.Text = "Breite (Tiles):";
			// 
			// groupBox5
			// 
			this.groupBox5.Controls.Add(this.label19);
			this.groupBox5.Controls.Add(this.label1);
			this.groupBox5.Controls.Add(this.numericUpDownZoom);
			this.groupBox5.Controls.Add(this.comboBoxScheme);
			this.groupBox5.Location = new System.Drawing.Point(8, 8);
			this.groupBox5.Name = "groupBox5";
			this.groupBox5.Size = new System.Drawing.Size(328, 72);
			this.groupBox5.TabIndex = 16;
			this.groupBox5.TabStop = false;
			this.groupBox5.Text = "Ansicht";
			// 
			// label19
			// 
			this.label19.AutoSize = true;
			this.label19.Location = new System.Drawing.Point(8, 43);
			this.label19.Name = "label19";
			this.label19.Size = new System.Drawing.Size(70, 16);
			this.label19.TabIndex = 16;
			this.label19.Text = "Farbschema:";
			// 
			// label1
			// 
			this.label1.AutoSize = true;
			this.label1.Location = new System.Drawing.Point(8, 18);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(57, 16);
			this.label1.TabIndex = 0;
			this.label1.Text = "Zoom (%):";
			// 
			// numericUpDownZoom
			// 
			this.numericUpDownZoom.Increment = new System.Decimal(new int[] {
																				100,
																				0,
																				0,
																				0});
			this.numericUpDownZoom.Location = new System.Drawing.Point(104, 16);
			this.numericUpDownZoom.Maximum = new System.Decimal(new int[] {
																			  3200,
																			  0,
																			  0,
																			  0});
			this.numericUpDownZoom.Minimum = new System.Decimal(new int[] {
																			  100,
																			  0,
																			  0,
																			  0});
			this.numericUpDownZoom.Name = "numericUpDownZoom";
			this.numericUpDownZoom.Size = new System.Drawing.Size(48, 20);
			this.numericUpDownZoom.TabIndex = 1;
			this.numericUpDownZoom.Value = new System.Decimal(new int[] {
																			300,
																			0,
																			0,
																			0});
			this.numericUpDownZoom.ValueChanged += new System.EventHandler(this.doRefresh);
			// 
			// comboBoxScheme
			// 
			this.comboBoxScheme.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboBoxScheme.Location = new System.Drawing.Point(104, 40);
			this.comboBoxScheme.MaxDropDownItems = 12;
			this.comboBoxScheme.Name = "comboBoxScheme";
			this.comboBoxScheme.Size = new System.Drawing.Size(216, 21);
			this.comboBoxScheme.TabIndex = 15;
			this.comboBoxScheme.SelectedIndexChanged += new System.EventHandler(this.comboBoxScheme_SelectedIndexChanged);
			// 
			// saveFileDialog1
			// 
			this.saveFileDialog1.DefaultExt = "xml";
			this.saveFileDialog1.Filter = "Level (*.xml)|*.xml|Bitmap (*.bmp)|*.bmp|PNG (*.png)|*.png|Alle Dateien (*.*)|*.*" +
				"";
			this.saveFileDialog1.Title = "Speichern unter";
			// 
			// openFileDialog1
			// 
			this.openFileDialog1.Filter = "Level (*.xml)|*.xml|Bitmap (*.bmp)|*.bmp|Alle Dateien (*.*)|*.*";
			this.openFileDialog1.Title = "Öffnen";
			// 
			// splitter1
			// 
			this.splitter1.BackColor = System.Drawing.Color.Black;
			this.splitter1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Right;
			this.splitter1.Location = new System.Drawing.Point(447, 0);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(1, 574);
			this.splitter1.TabIndex = 1;
			this.splitter1.TabStop = false;
			// 
			// panel1
			// 
			this.panel1.AutoScroll = true;
			this.panel1.Controls.Add(this.pictureBox1);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(447, 574);
			this.panel1.TabIndex = 2;
			// 
			// pictureBox1
			// 
			this.pictureBox1.BackColor = System.Drawing.SystemColors.Control;
			this.pictureBox1.Cursor = System.Windows.Forms.Cursors.NoMove2D;
			this.pictureBox1.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox1.Image")));
			this.pictureBox1.Location = new System.Drawing.Point(0, 0);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(300, 150);
			this.pictureBox1.TabIndex = 3;
			this.pictureBox1.TabStop = false;
			this.pictureBox1.Paint += new System.Windows.Forms.PaintEventHandler(this.pictureBox1_Paint);
			this.pictureBox1.MouseMove += new System.Windows.Forms.MouseEventHandler(this.MapForm_MouseMove);
			this.pictureBox1.MouseDown += new System.Windows.Forms.MouseEventHandler(this.panel1_MouseDown);
			// 
			// MapForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(792, 574);
			this.Controls.Add(this.panel1);
			this.Controls.Add(this.splitter1);
			this.Controls.Add(this.panelToolbar);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "MapForm";
			this.Text = "Glow Map-Tool von Thiemo Mättig";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.MouseMove += new System.Windows.Forms.MouseEventHandler(this.MapForm_MouseMove);
			this.panelToolbar.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownBack)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownHeight)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownWidth)).EndInit();
			this.groupBox4.ResumeLayout(false);
			this.groupBox3.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownRetries)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownRndFloors)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownRndRooms)).EndInit();
			this.groupBox2.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownRHF)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownRWF)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownRHT)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownRWT)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownWall)).EndInit();
			this.groupBox1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownHill)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownThickness)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownBackUp)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownBackDown)).EndInit();
			this.groupBox5.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownZoom)).EndInit();
			this.panel1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Der Haupteinstiegspunkt für die Anwendung.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MapForm());
		}

		private void doRefresh(object sender, System.EventArgs e)
		{
			pictureBox1.Refresh();
		}

		/* private void FormMain_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			int w = width;
			int h = height;
			int z = zoom;
			Brush[] brushes = new Brush[3];
			brushes[0] = Brushes.LightGray;
			brushes[1] = Brushes.Gray;
			brushes[2] = Brushes.DarkRed;
			Brush brushEntity = Brushes.DarkGreen;
			Pen penEntity = Pens.DarkGreen;

			e.Graphics.DrawRectangle(Pens.Black, -1, -1, w * z + 1, h * z + 1);
			e.Graphics.FillRectangle(Brushes.White, 0, 0, w * z, h * z);
			for (int y = 0; y < h; y++)
			{
				for (int x = 0; x < w; x++)
				{
					if (map[x, y] >= 0)
						e.Graphics.FillRectangle(brushes[map[x, y]], x * z, y * z, z, z);
				}
			}
			foreach (Entity entity in entities)
			{
				if (entity.X != entity.ToX || entity.Y != entity.ToY)
				{
					e.Graphics.DrawLine(penEntity,
						(entity.X + entity.Width / 2f) * z,
						(entity.Y + entity.Height / 2f) * z,
						(entity.ToX + entity.Width / 2f) * z,
						(entity.ToY + entity.Height / 2f) * z);
					if (z < 3)
						e.Graphics.FillRectangle(brushEntity, entity.ToX * z, entity.ToY * z,
							entity.Width * z, entity.Height * z);
					else
						e.Graphics.DrawRectangle(penEntity, entity.ToX * z, entity.ToY * z,
							entity.Width * z - 1, entity.Height * z - 1);
				}
				e.Graphics.FillRectangle(brushEntity, entity.X * z, entity.Y * z,
					entity.Width * z, entity.Height * z);
			}
			e.Graphics.FillRectangle(Brushes.Black, w * z + 10, 10, 2 * z, 4 * z);
			e.Graphics.DrawString("Stevie ist so groß", Font, Brushes.Black, (w + 2) * z + 12, 7);
		} */

		private void pictureBox1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			e.Graphics.FillRectangle(new SolidBrush(Color.FromArgb(255, 127, 127, 127)), 0, 0,
				width * zoom, height * zoom);
			doPaint(e.Graphics);
		}

		private static Color parseColor(XmlNode node)
		{
			return Color.FromArgb(
				Math.Min(255, (int)Math.Round(Convert.ToDouble(
					node.Attributes["alpha"].Value, provider) * 255.0)),
				Convert.ToInt32(node.Attributes["red"].Value, provider),
				Convert.ToInt32(node.Attributes["green"].Value, provider),
				Convert.ToInt32(node.Attributes["blue"].Value, provider));
		}

		private void doPaint(Graphics g)
		{
			XmlNode node;

			int w = width;
			int h = height;
			int z = zoom;
			pictureBox1.Size = new System.Drawing.Size((w + 2) * z + 105, h * z);
			Brush[] brushes = new Brush[3];
			for (int i = 0; i <= 2; i++)
			{
				node = cfg.SelectSingleNode("*/Colorscheme[@name='"
					+ comboBoxScheme.SelectedItem + "']/Layer[@id=" + i + "]");
				if (node == null)
					return;
				brushes[i] = new SolidBrush(parseColor(node));
			}
			node = cfg.SelectSingleNode("*/Colorscheme[@name='"
				+ comboBoxScheme.SelectedItem + "']/Entities");
			if (node == null)
				return;
			Color colorEntity = parseColor(node);
			Brush brushEntity = new SolidBrush(colorEntity);
			Pen penEntity = new Pen(colorEntity);

			node = cfg.SelectSingleNode("*/Colorscheme[@name='"
				+ comboBoxScheme.SelectedItem + "']/Background");
			if (node == null)
				return;
			g.FillRectangle(Brushes.Black, 0, 0, w * z, h * z);
			g.FillRectangle(new SolidBrush(parseColor(node)), 0, 0, w * z, h * z);
			for (int y = 0; y < h; y++)
			{
				for (int x = 0; x < w; x++)
				{
					if (map[x, y] >= 0)
						g.FillRectangle(brushes[map[x, y]], x * z, y * z, z, z);
				}
			}
			foreach (Entity entity in entities)
			{
				if (entity.X != entity.ToX || entity.Y != entity.ToY)
				{
					g.DrawLine(penEntity,
						(entity.X + entity.Width / 2f) * z,
						(entity.Y + entity.Height / 2f) * z,
						(entity.ToX + entity.Width / 2f) * z,
						(entity.ToY + entity.Height / 2f) * z);
					if (z < 3)
						g.FillRectangle(brushEntity, entity.ToX * z, entity.ToY * z,
							entity.Width * z, entity.Height * z);
					else
						g.DrawRectangle(penEntity, entity.ToX * z, entity.ToY * z,
							entity.Width * z - 1, entity.Height * z - 1);
				}
				Brush brushExtra = null;
				if (entity.ColorName != null)
				{
					brushExtra = new SolidBrush(parseColor(cfg.SelectSingleNode(
						"*/Colorscheme[@name='" + comboBoxScheme.SelectedItem
						+ "']/Color[@name='" + entity.ColorName + "']")));
				}
				if (z >= 6 && entity.Width <= 1 && entity.Height <= 1)
					g.FillEllipse(
						brushExtra == null ? brushEntity : brushExtra,
						entity.X * z - 1, entity.Y * z - 1,
						entity.Width * z + 1, entity.Height * z + 1);
				else
					g.FillRectangle(
						brushExtra == null ? brushEntity : brushExtra,
						entity.X * z, entity.Y * z,
						entity.Width * z, entity.Height * z);
			}
			g.FillRectangle(Brushes.Black, w * z + 10, 10, 2 * z, 4 * z);
			g.DrawString("Stevie ist so groß", Font, Brushes.Black, (w + 2) * z + 12, 7);
		}

		private void setTile(int x, int y)
		{
			setTile(x, y, 1);
		}

		private void setTile(int x, int y, short type)
		{
			if (x < 0 || y < 0 || x >= map.GetLength(0) || y >= map.GetLength(1))
				return;
			map[x, y] = type;
		}
		private bool tileEquals(int x, int y, int type)
		{
			if (x < 0 || y < 0 || x >= map.GetLength(0) || y > map.GetLength(1))
				return false;
			return map[x, y] == type;
		}

		private void doFill(short type)
		{
			doFill(type, -2);
		}

		private void doFill(short type, short excludeType)
		{
			doFill(type, excludeType, 100);
		}

		private void doFill(short type, short excludeType, decimal percent)
		{
			int start = (int)Math.Round(height * (100 - percent) / 100);
			if (start % 2 != 0) start++;
			int w = map.GetLength(0);
			int h = map.GetLength(1);
			for (int y = start; y < h; y++)
				for (int x = 0; x < w; x++)
					if (map[x, y] != excludeType)
						map[x, y] = type;
		}

		private void doPath(short type, bool tunnel)
		{
			int thicknessUp = (int)numericUpDownBackUp.Value;
			int thickness = (int)numericUpDownThickness.Value;
			int thicknessDown = (int)numericUpDownBackDown.Value;
			int yStart = rand.Next(height - thickness + 1);
			int yEnd = rand.Next(height - thickness + 1);
			if (checkBoxSymmetry.Checked) yEnd = yStart;
			pathPart(-1, yStart, width, yEnd, type, tunnel);
		}

		private void pathPart(int x1, int y1, int x2, int y2, short type, bool tunnel)
		{
			int retries = (int)numericUpDownRetries.Value;
			int thicknessUp = (int)numericUpDownBackUp.Value;
			int thickness = (int)numericUpDownThickness.Value;
			int thicknessDown = (int)numericUpDownBackDown.Value;
			int x3 = (x1 + x2) / 2;
			int y3 = y1;
			int r = (int)((x2 - x1) / numericUpDownHill.Value);
			if (! tunnel)
				for (int i = 0; i < retries; i++)
				{
					y3 = (y1 + y2) / 2 + rand.Next(r) - r / 2;
					if (y3 < 0 || y3 > height - thickness)
						continue;
					if (! tileEquals(x3, y3 - 1, 1) && ! tileEquals(x3, y3 + thickness + 0, 1) &&
						! tileEquals(x3, y3 - 2, 1) && ! tileEquals(x3, y3 + thickness + 1, 1) &&
						! tileEquals(x3, y3 - 3, 1) && ! tileEquals(x3, y3 + thickness + 2, 1) &&
						! tileEquals(x3, y3 - 4, 1) && ! tileEquals(x3, y3 + thickness + 3, 1))
						break;
				}
			else
				for (int i = 0; i < 100; i++)
				{
					y3 = (y1 + y2) / 2 + rand.Next(r) - r / 2;
					if (y3 < 0 || y3 > height - thickness)
						continue;
					if (tileEquals(x3, y3 - 1, 1) && tileEquals(x3, y3 + thickness + 0, 1) &&
						tileEquals(x3, y3 - 2, 1) && tileEquals(x3, y3 + thickness + 1, 1) &&
						tileEquals(x3, y3 - 3, 1) && tileEquals(x3, y3 + thickness + 2, 1) &&
						tileEquals(x3, y3 - 4, 1) && tileEquals(x3, y3 + thickness + 3, 1))
						break;
				}
			for (int i = 0; i < thickness; i++)
				setTile(x3, y3 + i, type);
			if (! tunnel)
			{
				for (int i = 1; i <= thicknessUp; i++)
				{
					if (! tileEquals(x3, y3 - i, 1))
						setTile(x3, y3 - i, 0);
				}
				for (int i = 0; i < thicknessDown; i++)
				{
					if (! tileEquals(x3, y3 + thickness + i, 1))
						setTile(x3, y3 + thickness + i, 0);
				}
			}
			else
			{
				for (int i = 0; i < thicknessDown; i++)
				{
					if (! tileEquals(x3, y3 + i, 1))
						setTile(x3, y3 + i, 0);
				}
				for (int i = 1; i <= thicknessUp; i++)
				{
					if (! tileEquals(x3, y3 + thickness - i, 1))
						setTile(x3, y3 + thickness - i, 0);
				}
			}
			if (x1 < x3 - 1) pathPart(x1, y1, x3, y3, type, tunnel);
			if (x2 > x3 + 1) pathPart(x3, y3, x2, y2, type, tunnel);
		}

		private void doRoom()
		{
			int retries = (int)numericUpDownRetries.Value;
			int t = (int)numericUpDownWall.Value;
			short background = -1;
			if (checkBoxClose.Checked) background = 0;
			int w = (int)numericUpDownRWF.Value;
			w += rand.Next((int)numericUpDownRWT.Value - (int)numericUpDownRWF.Value);
			int h = (int)numericUpDownRHF.Value;
			h += rand.Next((int)numericUpDownRHT.Value - (int)numericUpDownRHF.Value);
			// Korrektur, damit alles schön mit großen Steinen klappt.
			if (w % 2 > 0) w++;
			if (h % 2 > 0) h++;
			if (w > width - 2 * t) w = width - 2 * t;
			if (h > height - 2 * t) h = height - 2 * t;
			int x = 0, y = 0;
			for (int i = 0; i < retries; i++)
			{
				x = t + rand.Next(width - w - 2 * t + 1);
				y = t + rand.Next(height - h - 2 * t + 1);
				// Korrektur, damit alles schön mit großen Steinen klappt.
				if (x % 2 > 0) x--;
				if (y % 2 > 0) y--;
				if (y + h + t >= height ||
					(x - t > 0 &&
					map[x - t - 1, y + h - 1] != 1 &&
					map[x - t - 1, y + h] == 1) ||
					(map[x + w + t, y + h - 1] != 1 &&
					map[x + w + t, y + h] == 1))
					break;
			}
			for (int yd = -t; yd < h + t; yd++)
			{
				if (y + yd < 0) continue;
				for (int xd = -t; xd < w + t; xd++)
				{
					if (x + xd < 0) continue;
					map[x + xd, y + yd] = 1;
				}
			}
			for (int yd = 0; yd < h; yd++)
				for (int xd = 0; xd < w; xd++)
					map[x + xd, y + yd] = background;
		}

		private void doOptimize()
		{
			// Beim Optimieren der Normalen Ebene wird der Hintergrund ignoriert.
			for (int y = 0; y < height - 1; y += 2)
			{
				for (int x = 0; x < width - 1; x += 2)
				{
					// Wenn nur eine der vier Ecken fehlt, dann ausfüllen.
					if (map[x,     y    ] <  1 && map[x + 1, y    ] == 1 &&
						map[x,     y + 1] == 1 && map[x + 1, y + 1] == 1)
						map[x, y] = 1;
					else if (map[x, y   ] == 1 && map[x + 1, y    ] <  1 &&
						map[x,     y + 1] == 1 && map[x + 1, y + 1] == 1)
						map[x + 1, y] = 1;
					else if (map[x, y   ] == 1 && map[x + 1, y    ] == 1 &&
						map[x,     y + 1] <  1 && map[x + 1, y + 1] == 1)
						map[x, y + 1] = 1;
					else if (map[x, y   ] == 1 && map[x + 1, y    ] == 1 &&
						map[x,     y + 1] == 1 && map[x + 1, y + 1] <  1)
						map[x + 1, y + 1] = 1;
				}
			}
			// Das Selbe nochmal für den Hintergrund.
			for (int y = 0; y < height - 1; y += 2)
			{
				for (int x = 0; x < width - 1; x += 2)
				{
					// Wenn nur eine der vier Ecken fehlt, dann ausfüllen.
					if (map[x,     y    ] <  0 && map[x + 1, y    ] == 0 &&
						map[x,     y + 1] == 0 && map[x + 1, y + 1] == 0)
						map[x, y] = 0;
					else if (map[x, y   ] == 0 && map[x + 1, y    ] <  0 &&
						map[x,     y + 1] == 0 && map[x + 1, y + 1] == 0)
						map[x + 1, y] = 0;
					else if (map[x, y   ] == 0 && map[x + 1, y    ] == 0 &&
						map[x,     y + 1] <  0 && map[x + 1, y + 1] == 0)
						map[x, y + 1] = 0;
					else if (map[x, y   ] == 0 && map[x + 1, y    ] == 0 &&
						map[x,     y + 1] == 0 && map[x + 1, y + 1] <  0)
						map[x + 1, y + 1] = 0;
				}
			}
			/* int[,] tiles = getTileMap();
			int[] counts = new int[3];
			for (int yd = 0; yd <= 1; yd++)
			{
				for (int y = yd; y < height - 1; y += 2)
				{
					for (int x = 0; x < width - 1; x++)
					{
						counts[0] = 0;
						counts[1] = 0;
						counts[2] = 0;
						counts[map[x    , y    ]]++;
						counts[map[x + 1, y    ]]++;
						counts[map[x    , y + 1]]++;
						counts[map[x + 1, y + 1]]++;

						// Wenn nur eine der vier Ecken fehlt, dann ausfüllen.
						if (map[x,     y    ] <  1 && tiles[x + 1, y    ] == 1 &&
							map[x,     y + 1] == 1 && map[x + 1, y + 1] == 1)
							map[x, y] = 1;
						else if (map[x, y   ] == 1 && map[x + 1, y    ] <  1 &&
							map[x,     y + 1] == 1 && map[x + 1, y + 1] == 1)
							map[x + 1, y] = 1;
						else if (map[x, y   ] == 1 && map[x + 1, y    ] == 1 &&
							map[x,     y + 1] <  1 && map[x + 1, y + 1] == 1)
							map[x, y + 1] = 1;
						else if (map[x, y   ] == 1 && map[x + 1, y    ] == 1 &&
							map[x,     y + 1] == 1 && map[x + 1, y + 1] <  1)
							map[x + 1, y + 1] = 1;
					}
				}
			} */
		}

		/* private void doOpen(string filename)
		{
			StreamReader reader = File.OpenText(filename);
			string line;
			Regex regexHead = new Regex("width=\"([0-9]*)\" *height=\"([0-9]*)\"",
				RegexOptions.IgnoreCase);
			Regex regexTile = new Regex("layer=\"([0-9]*)\" *x=\"([0-9]*)\" *y=\"([0-9]*)\"",
				RegexOptions.IgnoreCase);
			Regex regexSet = new Regex("set=\"(Platte Set [1-4])\"");
			Regex regexSetBG = new Regex("set=\"(Platte BG Set [1-4])\"");
			bool setFound = false, setBGFound = false;
			width = 1000;
			height = 1000;
			doFill(-1);
			while ((line = reader.ReadLine()) != null)
			{
				Match m = regexTile.Match(line);
				if (m.Success)
				{
					short layer = Convert.ToInt16(m.Groups[1].Value);
					int x = Convert.ToInt32(m.Groups[2].Value);
					int y = Convert.ToInt32(m.Groups[3].Value);
					if (layer > 0)
						map[x, y] = 1;
					else if (map[x, y] < 1)
						map[x, y] = layer;
					if (! setFound)
					{
						m = regexSet.Match(line);
						if (m.Success)
						{
							comboBoxSet.SelectedItem = m.Groups[1].Value;
							setFound = true;
						}
					}
					else if (! setBGFound)
					{
						m = regexSetBG.Match(line);
						if (m.Success)
						{
							comboBoxSetBG.SelectedItem = m.Groups[1].Value;
							setBGFound = true;
						}
					}
				}
				else
				{
					m = regexHead.Match(line);
					if (m.Success)
					{
						try
						{
							width = Convert.ToInt32(m.Groups[1].Value);
							height = Convert.ToInt32(m.Groups[2].Value);
						}
						catch
						{
							MessageBox.Show("Dateiformat nicht lesbar!");
							return;
						}
					}
				}
			}
			reader.Close();
		} */
		private void doOpen(string filename)
		{
			XmlDocument doc = new XmlDocument();
			try
			{
				doc.Load(filename);
				width = Convert.ToInt32(doc.DocumentElement.Attributes["width"].Value);
				height = Convert.ToInt32(doc.DocumentElement.Attributes["height"].Value);
				XmlNode node = doc.SelectSingleNode("*/Tile[@l=1 or @layer=1]/@*[name()='s' or name()='set']");
				if (node != null)
					comboBoxSet.SelectedItem = node.Value;
				node = doc.SelectSingleNode("*/Tile[@l=0 or @layer=0 or (not(@l) and not(@layer))]/@*[name()='s' or name()='set']");
				if (node != null)
					comboBoxSetBG.SelectedItem = node.Value;
				// Clear.
				doFill(-1);
				foreach (XmlNode tile in doc.SelectNodes("*/Tile[@l=0 or @layer=0 or (not(@l) and not(@layer))]"))
					map[Convert.ToInt32(tile.Attributes["x"].Value),
						Convert.ToInt32(tile.Attributes["y"].Value)] = 0;
				foreach (XmlNode tile in doc.SelectNodes("*/Tile[@l=2 or @layer=2]"))
					map[Convert.ToInt32(tile.Attributes["x"].Value),
						Convert.ToInt32(tile.Attributes["y"].Value)] = 2;
				foreach (XmlNode tile in doc.SelectNodes("*/Tile[@l=1 or @layer=1]"))
					map[Convert.ToInt32(tile.Attributes["x"].Value),
						Convert.ToInt32(tile.Attributes["y"].Value)] = 1;
				entities.Clear();
				foreach (XmlNode xmlEntity in doc.SelectNodes("*/Entity"))
				{
					entities.Add(xmlEntity);
				}
			}
			catch
			{
				MessageBox.Show(this, "Dateiformat nicht lesbar!", "Fehler");
			}
		}

		private void doOpenBitmap(string filename)
		{
			float b;
			try
			{
				Bitmap bmp = new Bitmap(filename);
				// Clear.
				doFill(-1);
				width = bmp.Width;
				height = bmp.Height;
				for (int y = bmp.Height - 1; y >= 0; y--)
				{
					for (int x = bmp.Width - 1; x >= 0; x--)
					{
						b = bmp.GetPixel(x, y).GetBrightness();
						if (b <= 0.1)
							map[x, y] = 1;
						else if (b < 0.9)
							map[x, y] = 0;
					}
				}
				bmp.Dispose();
			}
			catch
			{
				MessageBox.Show(this, "Dateiformat nicht lesbar!", "Fehler");
				return;
			}
		}

		private int[,] getTileMap()
		{
			/*
			 * Zu kodieren:
			 * Layer = 0..2 = 2 Bit
			 * Set ist schon ausgewählt
			 * Group = 1..?? = 4 oder besser 5 Bit
			 * Offset = 0..15 = 4 Bit
			 * ushort hat 16 Bit
			 */
			int[,] tiles = new int[width, height];
			int group = 0;

			/*
			 * 4 x 2 => Group 3, 4, 11, 12, Offset 0..7
			 */
			for (int yd = 0; yd <= 3; yd++)
			{
				for (int xd = 0; xd <= 3; xd++)
				{
					for (int y = yd; y < height - 1; y += 2)
					{
						for (int x = xd + ((y - yd) % 4); x < width - 3; x += 4)
						{
							if (map[x, y] < 0) continue;
							if (map[x, y] == map[x + 1, y    ] &&
								map[x, y] == map[x + 2, y    ] && map[x, y] == map[x + 3, y    ] &&
								map[x, y] == map[x    , y + 1] && map[x, y] == map[x + 1, y + 1] &&
								map[x, y] == map[x + 2, y + 1] && map[x, y] == map[x + 3, y + 1] &&
								tiles[x    , y    ] == 0 && tiles[x + 1, y    ] == 0 &&
								tiles[x + 2, y    ] == 0 && tiles[x + 3, y    ] == 0 &&
								tiles[x    , y + 1] == 0 && tiles[x + 1, y + 1] == 0 &&
								tiles[x + 2, y + 1] == 0 && tiles[x + 3, y + 1] == 0)
							{
								group = (3 + ((8 + rand.Next(4)) % 10)) << 4;
								tiles[x    , y    ] = group;
								tiles[x + 1, y    ] = group + 1;
								tiles[x + 2, y    ] = group + 2;
								tiles[x + 3, y    ] = group + 3;
								tiles[x    , y + 1] = group + 4;
								tiles[x + 1, y + 1] = group + 5;
								tiles[x + 2, y + 1] = group + 6;
								tiles[x + 3, y + 1] = group + 7;
							}
						}
					}
				}
			}

			/*
			 * 2 x 2 => Group 1, 2, 9, 10, Offset 0..4
			 */
			for (int yd = 0; yd <= 3; yd++)
			{
				for (int xd = 0; xd <= 1; xd++)
				{
					for (int y = yd; y < height - 1; y += 2)
					{
						for (int x = xd + (((y - yd) >> 1) % 2); x < width - 1; x += 2)
						{
							if (map[x, y] < 0) continue;
							if (map[x, y] == map[x + 1, y] &&
								map[x, y] == map[x, y + 1] && map[x, y] == map[x + 1, y + 1] &&
								tiles[x, y    ] == 0 && tiles[x + 1, y    ] == 0 &&
								tiles[x, y + 1] == 0 && tiles[x + 1, y + 1] == 0)
							{
								group = (1 + ((8 + rand.Next(4)) % 10)) << 4;
								tiles[x    , y    ] = group;
								tiles[x + 1, y    ] = group + 1;
								tiles[x    , y + 1] = group + 2;
								tiles[x + 1, y + 1] = group + 3;
							}
						}
					}
				}
			}

			/*
			 * 1 x 1 => Group 7, 8, 15, 16, Offset 0
			 */
			for (int y = 0; y < height; y++)
			{
				for (int x = 0; x < width; x++)
				{
					if (map[x, y] >= 0 && tiles[x, y] == 0)
					{
						group = 7 + ((8 + rand.Next(4)) % 10);
						tiles[x, y] = (group << 4);
					}
				}
			}

			return tiles;
		}

		/* private void doSave1(string filename)
		{
			string filenameTemplate = Application.StartupPath + Path.DirectorySeparatorChar + "Template.dat";
			string footer = "", format = "";
			string[] platteSet = new string[3];
			platteSet[0] = comboBoxBack.SelectedItem.ToString();
			platteSet[1] = comboBoxMain.SelectedItem.ToString();
			platteSet[2] = comboBoxMain.SelectedItem.ToString();
			string[] platteGroup = new string[3];
			platteGroup[0] = "BG";
			platteGroup[1] = "";
			platteGroup[2] = "";

			StreamWriter writer = File.CreateText(filename);
			StreamReader reader = File.OpenText(filenameTemplate);
			string template = reader.ReadToEnd();
			reader.Close();
			string[] templateParts = template.Split("#".ToCharArray());
			writer.Write(templateParts[0], width, height);
			format = templateParts[1];
			footer = templateParts[2];
			for (int y = 0; y < height; y++)
			{
				for (int x = 0; x < width; x++)
				{
					if (map[x, y] < 0) continue;
					object[] tileParams
						= { map[x, y], x, y,
							  platteSet[map[x, y]], platteGroup[map[x, y]], 8, 0 };
					writer.Write(format, tileParams);
				}
			}
			writer.Write(footer);
			writer.Close();
		} */

		private void doSave(string filename)
		{
			int[,] tiles = getTileMap();
			string footer = "", format = "";
			string[] platteSet = new string[3];
			string[] platteGroup = new string[3];
			platteSet[0] = comboBoxSetBG.SelectedItem.ToString();
			platteSet[1] = comboBoxSet.SelectedItem.ToString();
			platteSet[2] = comboBoxSet.SelectedItem.ToString();
			platteGroup[0] = platteSet[0].StartsWith("Platte BG") ? "BG" : "";
			platteGroup[1] = platteSet[1].StartsWith("Platte BG") ? "BG" : "";
			platteGroup[2] = platteSet[2].StartsWith("Platte BG") ? "BG" : "";

			StreamWriter writer = File.CreateText(filename);
			writer.Write(cfg.SelectSingleNode("*/Template/Header").InnerText, width, height);
			format = cfg.SelectSingleNode("*/Template/Tile").InnerText;
			footer = cfg.SelectSingleNode("*/Template/Footer").InnerText;
			for (int y = 0; y < height; y++)
			{
				for (int x = 0; x < width; x++)
				{
					if (map[x, y] < 0) continue;
					object[] tileParams
						= { map[x, y], x, y,
							  platteSet[map[x, y]], platteGroup[map[x, y]],
							  (tiles[x, y] >> 4) & 31, tiles[x, y] & 15 };
					writer.Write(format, tileParams);
				}
			}
			writer.Write(footer);
			writer.Close();
		}
		private void buttonClear_Click(object sender, System.EventArgs e)
		{
			doFill(-1);
			entities.Clear();
			pictureBox1.Refresh();
		}

		private void buttonFill_Click(object sender, System.EventArgs e)
		{
			doFill(1, -2, numericUpDownBack.Value);
			pictureBox1.Refresh();
		}

		private void buttonFillBG_Click(object sender, System.EventArgs e)
		{
			doFill(0, 1, numericUpDownBack.Value);
			pictureBox1.Refresh();
		}

		private void buttonLine_Click(object sender, System.EventArgs e)
		{
			doPath(1, false);
			pictureBox1.Refresh();
		}

		private void buttonLineInv_Click(object sender, System.EventArgs e)
		{		
			doPath(-1, true);
			pictureBox1.Refresh();
		}

		private void numericUpDownRWF_ValueChanged(object sender, System.EventArgs e)
		{
			numericUpDownRWT.Minimum = ((NumericUpDown)sender).Value;
		}
		private void numericUpDownRWT_ValueChanged(object sender, System.EventArgs e)
		{
			numericUpDownRWF.Maximum = ((NumericUpDown)sender).Value;
		}
		private void numericUpDownRHF_ValueChanged(object sender, System.EventArgs e)
		{
			numericUpDownRHT.Minimum = ((NumericUpDown)sender).Value;
		}
		private void numericUpDownRHT_ValueChanged(object sender, System.EventArgs e)
		{
			numericUpDownRHF.Maximum = ((NumericUpDown)sender).Value;
		}
		private void buttonRoom_Click(object sender, System.EventArgs e)
		{
			doRoom();
			pictureBox1.Refresh();
		}

		private void buttonRandom_Click(object sender, System.EventArgs e)
		{
			int anzahlEbenen = (int)numericUpDownRndFloors.Value;
			int anzahlRaeume = (int)numericUpDownRndRooms.Value;
			if (! checkBoxInv.Checked)
			{
				doFill(-1);
				for (int i = 0; i < anzahlEbenen; i++)
					doPath(1, false);
			}
			else
			{
				doFill(1);
				for (int i = 0; i < anzahlEbenen; i++)
					doPath(-1, true);
			}
			for (int i = 0; i < anzahlRaeume; i++)
				doRoom();
			doOptimize();
			entities.Clear();
			pictureBox1.Refresh();
		}

		private void buttonOptimize_Click(object sender, System.EventArgs e)
		{
			doOptimize();
			pictureBox1.Refresh();
		}

		private void buttonOpen_Click(object sender, System.EventArgs e)
		{
			if (openFileDialog1.ShowDialog() != DialogResult.OK)
				return;
			if (openFileDialog1.FileName.ToLower().EndsWith(".xml"))
			{
				doOpen(openFileDialog1.FileName);
				pictureBox1.Refresh();
				if (doWarning)
				{
					MessageBox.Show(this, "Achtung! Beim Speichern werden alle Klassen und Objekte gelöscht!");
					doWarning = false;
				}
			}
			else
			{
				doOpenBitmap(openFileDialog1.FileName);
				pictureBox1.Refresh();
			}
		}

		private void buttonSave_Click(object sender, System.EventArgs e)
		{
			if (openFileDialog1.FileName != "")
				saveFileDialog1.FileName =
					(saveFileDialog1.FileName == "" ? "" :
					new FileInfo(saveFileDialog1.FileName).DirectoryName + Path.DirectorySeparatorChar) +
					new FileInfo(openFileDialog1.FileName).Name.Replace(
					new FileInfo(openFileDialog1.FileName).Extension, "");
			if (saveFileDialog1.ShowDialog() != DialogResult.OK)
				return;
			if (saveFileDialog1.FileName.ToLower().EndsWith(".xml"))
				doSave(saveFileDialog1.FileName);
			else
			{
				Bitmap myBitmap = new Bitmap(width * zoom, height * zoom,
					System.Drawing.Imaging.PixelFormat.Format32bppArgb);
				doPaint(Graphics.FromImage(myBitmap));
				System.Drawing.Imaging.ImageFormat format = System.Drawing.Imaging.ImageFormat.Png;
				if (saveFileDialog1.FileName.ToLower().EndsWith(".bmp"))
					format = System.Drawing.Imaging.ImageFormat.Bmp;
				myBitmap.Save(saveFileDialog1.FileName, format);
			}
		}

		private void buttonFractal_Click(object sender, System.EventArgs e)
		{
			int x, y, w = width, h = height;
			x = w / 2;
			y = h / 2;
			if (map[x, y] < 0) map[x, y] = 0;
			for (int i = 0; i < 1000; i++)
			{
				x = rand.Next(w);
				y = rand.Next(h);
				if (map[x, y] >= 0) continue;
				int sum =
					(map[ x,              (y + h - 1) % h] >= 0 ? 1 : 0) +
					(map[(x + 1) % w,     (y + h - 1) % h] >= 0 ? 1 : 0) +
					(map[(x + 1) % w,      y             ] >= 0 ? 1 : 0) +
					(map[(x + 1) % w,     (y + 1) % h    ] >= 0 ? 1 : 0) +
					(map[ x,              (y + 1) % h    ] >= 0 ? 1 : 0) +
					(map[(x + w - 1) % w, (y + 1) % h    ] >= 0 ? 1 : 0) +
					(map[(x + w - 1) % w,  y             ] >= 0 ? 1 : 0) +
					(map[(x + w - 1) % w, (y + h - 1) % h] >= 0 ? 1 : 0);
				if (sum >= 1)
					map[x, y] = 0;
			}
			pictureBox1.Refresh();
		}

		private void comboBoxScheme_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			loadConfig();
			pictureBox1.Refresh();
		}

		private Point scrollDelta = new Point(0, 0);
		private void panel1_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			scrollDelta.X = MapForm.MousePosition.X - panel1.AutoScrollPosition.X;
			scrollDelta.Y = MapForm.MousePosition.Y - panel1.AutoScrollPosition.Y;
		}
		private void MapForm_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if (e.Button != MouseButtons.Left)
				return;
			panel1.AutoScrollPosition = new Point(
				scrollDelta.X - MapForm.MousePosition.X,
				scrollDelta.Y - MapForm.MousePosition.Y);
		}

		/* private void buttonFractal2_Click(object sender, System.EventArgs e)
		{
			double x = width / 2;
			double y = height / 2;
			doFractal(x, y, Math.PI, 1);
			Refresh();
		}
		private void doFractal(double x, double y, double angle, int depth)
		{
			double ad = 0.2;
			if (depth > 10) return;
			double x2 = x + Math.Sin(angle) * 2;
			double y2 = y + Math.Cos(angle) * 2;
			x2 = (x2 + width) % width;
			y2 = (y2 + height) % height;
			map[(int)x2, (int)y2] = 0;
			doFractal(x2, y2, angle - ad, depth + 1);
			doFractal(x2, y2, angle + ad, depth + 1);
		} */
	}

	struct Entity
	{
		public int X;
		public int Y;
		public int Width;
		public int Height;
		public int ToX;
		public int ToY;
		public string ColorName;
		public Entity(int x, int y, int width, int height, int toX, int toY, string colorName)
		{
			X = x;
			Y = y;
			Width = width;
			Height = height;
			ToX = toX;
			ToY = toY;
			ColorName = colorName;
		}
	}
	class EntityList: ArrayList
	{
		public int Add(XmlNode node)
		{
			string[] p = node.SelectSingleNode("*/Vector3[@name='v3_Position']/@value").Value.
				Split(",".ToCharArray());
			string className = node.Attributes["class"].Value;
			foreach (XmlNode cfgNode in MapForm.cfg.SelectNodes("*/Excludes/Entity/@startsWith"))
			{
				if (className.StartsWith(cfgNode.Value))
					return -1;
			}

			int x = (int)Math.Floor(Convert.ToDouble(p[0], MapForm.provider) + 0.5) - 1;
			int y = (int)Math.Floor(Convert.ToDouble(p[1], MapForm.provider) + 0.5) - 1;
			int w = 1, h = 1, dx = 0, dy = 0;
			string colorName = null;
			/* if (className.StartsWith("C_Ladder"))
			{
				x--; w = 2; y--; h = 2;
			}
			else if (className.StartsWith("C_EnemyCrawler"))
			{
				x--; w = 2; y--; h = 3;
			}
			else if (className.StartsWith("C_EnemyBombDragon"))
			{
				x--; w = 4; y--; h = 2;
			}
			else if (className.StartsWith("C_EnemyFireDragon"))
			{
				x -= 2; w = 5; y--; h = 3;
			}
			else if (className.StartsWith("C_Enemy"))
			{
				// Gilt für Skeleton, Ringer, Virgin
				w = 2; y -= 2; h = 4;
			}
			else if (className.StartsWith("C_PlayerStart"))
			{
				x--; w = 2; y -= 2; h = 4;
			}
			else */
			if (className.StartsWith("C_Platform"))
			{
				if (className.EndsWith("1"))
				{
					x -= 1; w = 4; h = 2;
				}
				else if (className.EndsWith("2"))
				{
					x -= 3; w = 8; h = 2;
				}
				else
				{
					w = 2;
				}
				int l = (int)(
					Convert.ToDouble(node.SelectSingleNode("*/Int32[@name='i_TickDuration']/@value").Value, MapForm.provider) *
					Convert.ToDouble(node.SelectSingleNode("*/Float32[@name='f_Speed']/@value").Value, MapForm.provider));
				switch (node.SelectSingleNode("*/Int32[@name='i_Direction']/@value").Value)
				{
					case "0":          dy = -l; break;
					case "1": dx =  l; dy = -l; break;
					case "2": dx =  l;          break;
					case "3": dx =  l; dy =  l; break;
					case "4":          dy =  l; break;
					case "5": dx = -l; dy =  l; break;
					case "6": dx = -l;          break;
					case "7": dx = -l; dy = -l; break;
				}
			}
			else
			{
				foreach (XmlNode classDef in MapForm.cfg.SelectNodes("*/Class"))
				{
					if (className.StartsWith(classDef.Attributes["startsWith"].Value))
					{
						x += Convert.ToInt32(classDef.Attributes["dx"].Value);
						y += Convert.ToInt32(classDef.Attributes["dy"].Value);
						w = Convert.ToInt32(classDef.Attributes["width"].Value);
						h = Convert.ToInt32(classDef.Attributes["height"].Value);
						if (classDef.Attributes["color"] != null)
							colorName = classDef.Attributes["color"].Value;
						break;
					}
				}
			}
			return Add(new Entity(x, y, w, h, x + dx, y + dy, colorName));
		}
	}
}